/*
 exif353.h
 */
#ifndef _EXIF_H
#define _EXIF_H


void exif_invalidate(void);
int exif_rebuild(int frames); // reallocate meta buffer to store per-frame meta data (later output as Exif)
int exif_enable(int en);      // enable/disable Exif processing (both W/R)
int dir_find_tag (unsigned long tag); //!find location of the tag field in meta page using long tag (Exif tag and tag group)

inline void write_meta_raw_irq(char * data, int offset, int len); //write data to meta, called from IRQ
inline int write_meta_irq(char * data, int * indx,  unsigned long ltag, int len); //write data to meta, called from IRQ(len==0 => use field length)
inline void putlong_meta_raw_irq(unsigned long data, int offset); //write data to meta (4 bytes, big endian), called from IRQ
inline int putlong_meta_irq(unsigned long data, int * indx,  unsigned long ltag); //write data to meta (4 bytes, big endian), from IRQ
//void write_meta_raw_irq(char * data, int offset, int len); //write data to meta, called from IRQ
//int write_meta_irq(char * data, int * indx,  unsigned long ltag, int len); //write data to meta, called from IRQ(len==0 => use field length). Returns index of the written data, -1 if not written

void write_meta_raw(char * data, int offset, int len); //write data to meta, called from outside IRQ (atomic)
int write_meta(char * data, int * indx,  unsigned long ltag, int len); //write data to meta, from outside IRQ (atomic) (len==0 => use field length). Returns index of the written data, -1 if not written
void putlong_meta_raw(unsigned long data, int offset); //write data to meta (4 bytes, big endian), called from outside IRQ (atomic)
int putlong_meta(unsigned long data, int * indx,  unsigned long ltag); //write data to meta (4 bytes, big endian), from outside IRQ (atomic). Returns index of the written data, -1 if not written

char * encode_time(unsigned long sec, unsigned long usec);
int store_meta(void); //called from IRQ service - put current metadata to meta_buffer, return page index


#endif
