/*****************************************************************************
*!
*! FILE NAME  : bootconfig.h
*!
*! DESCRIPTION: Boot loader configuration
*!
*! ---------------------------------------------------------------------------
*! (C) Copyright 2006-2007, Axis Communications AB, LUND, SWEDEN
*!
*! This program is free software; you can redistribute it and/or modify
*! it under the terms of the GNU General Public License as published by
*! the Free Software Foundation; either version 2 of the License, or
*! (at your option) any later version.
*!
*! This program is distributed in the hope that it will be useful,
*! but WITHOUT ANY WARRANTY; without even the implied warranty of
*! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*! GNU General Public License for more details.
*!
*! You should have received a copy of the GNU General Public License
*! along with this program; if not, write to the Free Software
*! Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*!
*!***************************************************************************/

#ifndef _BOOTCONFIG_H_
#define _BOOTCONFIG_H_

#define RAM_INIT_MAGIC 0x56902387
#define NAND_BOOT_MAGIC 0x9A9DB001

#ifdef NANDBOOT_LINUX

#include <linux/autoconf.h>
#define FETCH_ADDR (CONFIG_ETRAX_PTABLE_SECTOR)
#define STORE_ADDR (CONFIG_ETRAX_PTABLE_SECTOR + 0x40400000) /* dram + 4Meg */
#define LOAD_SIZE  (1024 * 1024 * 2)
#define BOOT_ADDR  STORE_ADDR

#else
#ifdef NANDBOOT_AXISRFL

#define FETCH_ADDR (0x4000) /* +16k */
#define STORE_ADDR (0x40000000) /* dram */
#define LOAD_SIZE  (1024 * 128)
#define BOOT_ADDR  STORE_ADDR

#else

#error No boot parameters defined. Cannot configure boot loader. Stop.

#endif
#endif

#endif /* _BOOTCONFIG_H_ */
