/*****************************************************************************
*!
*! FILE NAME  : delay.c
*!
*! DESCRIPTION: Precise delay loops for ETRAX FS.
*!		Trivial mod. for boot loader.
*!
*! ---------------------------------------------------------------------------
*! (C) Copyright 2006-2007, Axis Communications AB, LUND, SWEDEN
*!
*! This program is free software; you can redistribute it and/or modify
*! it under the terms of the GNU General Public License version 2 as 
*! published by the Free Software Foundation.
*!
*! This program is distributed in the hope that it will be useful,
*! but WITHOUT ANY WARRANTY; without even the implied warranty of
*! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*! GNU General Public License for more details.
*!
*! You should have received a copy of the GNU General Public License
*! along with this program; if not, write to the Free Software
*! Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*!
*!***************************************************************************/

#include <asm/arch/hwregs/reg_map.h>
#include <asm/arch/hwregs/reg_rdwr.h>
#include <asm/arch/hwregs/timer_defs.h>
#include <linux/types.h>
#include "delay.h"

/*
 * On ETRAX FS, we can check the free-running read-only 100MHz timer
 * getting 32-bit 10ns precision, theoretically good for 42.94967295
 * seconds.  Unsigned arithmetic and careful expression handles
 * wrapping.
 */

void cris_delay10ns(u32 n10ns)
{
	u32 t0 = REG_RD(timer, regi_timer, r_time);
	while (REG_RD(timer, regi_timer, r_time) - t0 < n10ns)
		;
}
