#!/bin/sh
. /etc/init.d/functions.sh

. /var/state/ctype

if [ "$ctype" != "CMOS" ] ; then
	exit 0
fi

#######################
# autoexp
#
echo "start autoexp"
/usr/local/bin/autoexp &

autoexp_conf=0
if [ $autoexp_conf != "0" ] ; then
	echo "configure autoexp"

	AUTOEXP_CTRL=/usr/local/bin/autoexp_ctrl
	. /etc/autoexp.conf
	COMMAND=" -s "
	if [ -n "$autoexp_win_width" ] ; then
		COMMAND=$COMMAND" -w $autoexp_win_width"
	fi
	if [ -n "$autoexp_win_height" ] ; then
		COMMAND=$COMMAND" -h $autoexp_win_height"
	fi
	if [ -n "$autoexp_win_left" ] ; then
		COMMAND=$COMMAND" -l $autoexp_win_left"
	fi
	if [ -n "$autoexp_win_top" ] ; then
		COMMAND=$COMMAND" -t $autoexp_win_top"
	fi
	if [ -n "$autoexp_max" ] ; then
		COMMAND=$COMMAND" -m $autoexp_max"
	fi
	if [ -n "$autoexp_over_max" ] ; then
		COMMAND=$COMMAND" -o $autoexp_over_max"
	fi
	$AUTOEXP_CTRL $COMMAND
fi

#######################
# ccamftp.conf
#

begin "start ccamftp"
/usr/local/bin/ccamftp.sh &
end 0

#######################
# streamer.conf
#

# set multicast address
flag=`grep 'dest_ip=232.X.Y.Z' /etc/streamer.conf`
if [ "$flag" != "" ] ; then
	SERNO=`bootblocktool -x SERNO`
	NEW_IP=`/usr/local/bin/helper_353 --serno_to_mcast $SERNO`
	if [ "$NEW_IP" = "" ] ; then
		NEW_IP="232.0.0.1"
	fi
	sed -e "s/dest_ip=232.X.Y.Z/dest_ip=${NEW_IP}/" /etc/streamer.conf > /var/state/streamer.conf
	cp /var/state/streamer.conf /etc/streamer.conf
fi

cp /etc/streamer.conf /var/state/streamer.conf

# configure image...

# Starting streamer and aquiring image 6 times (with some sleep between) - why?
# It is wrong to start sensor in the "fresh" camera (just reflashed) before actual image is requested
# It is also wrong to program default parameters with decimation (FPGA code is not optimized for that)
# so the code below is disabled for now

echo "Sensor access is DISABLED until image is requested"

# exit 0
# run streamer

begin "configure streamer"
echo "configure streamer" >> /var/state/cmd.txt
if [ -f /etc/streamer.conf ] ; then
	cp /etc/streamer.conf /var/state/streamer.conf
	. /etc/streamer.conf
echo "check autostart == " >> /var/state/cmd.txt
echo $autostart >> /var/state/cmd.txt
	if [ -f /etc/image_settings.conf ] ; then
	if [ "$autostart" == "true"  || "$autostart" == "1" ] ; then
# init image
		wget http://127.0.0.1/imconf_load.php -O - > /dev/null
		echo "check autostart - ok!" >> /var/state/cmd.txt
		cmd="/usr/local/bin/str "
		if [ "$maxfps" = "1" ] ; then
			cmd=$cmd" -f "$fps
		fi
		if [ "$name" = "unicast" ] ; then
			cmd=$cmd" -u "
		fi
		if [ "$name" = "multicast" ] ; then
			if [ "$dest_port" != "" ] ; then
				cmd=$cmd" -p "$dest_port
			fi
			if [ "$dest_ip" != "" ] ; then
				cmd=$cmd" -a "$dest_ip
			fi
			cmd=$cmd" -m "
		fi
		echo $cmd >> /var/state/cmd.txt
		$cmd &
	fi
	fi
fi
end $?
