#!/usr/local/sbin/php -q
<?php

$conf_file='/etc/launcher.conf.xml';
$state_done='/var/state/boot.done';

$conf_template = "<?xml version='1.0' standalone='yes'?>\n<launcher_cmd>\n<launch_example program=\"[patch]program_name\" log=\"log_file_name\" background=\"true|false\">'log' and 'background' is optional attributes; program can be with a full path</launch_example>\n</launcher_cmd>";

if(!is_file($conf_file)) {
	echo "launcher: write \"".$conf_file."\" config template\n";
	$f = fopen($conf_file, 'w');
	flock($f, LOCK_EX);
	fwrite($f, $conf_template);
	flock($f, LOCK_UN);
	fclose($f);
//	exit();
}

$xml = @new SimpleXMLElement(file_get_contents($conf_file));
$c = count($xml->launch);
if($c == 0) {
	echo "launcher: nothing to launch\n";
	$f = fopen($state_done, 'w');
	fwrite($f, "done");
	fclose($f);
	exit();
}

// <launch program="[patch]program_name" [log="log_file_name"] [background="true|false"]/>
for($i = 0; $i < $c; $i++) {
	$l = $xml->launch[$i];
	$program = $l['program'];
	if($program == "")
		continue;
	$cmd = $program;
	$cmd .= ' 2>&1 ';
//	$cmd .= ' > ';
	$log = ' /dev/null ';
	if($l['log'] != "")
		$log = $l['log'];
	// do fork for background
	if($l['background'] == "true") {
		$cmd = '('.$cmd.' &) > '.$log;
		echo 'launcher: run command: '.$cmd."\n";
		system($cmd);
	} else {
//	$cmd = "(/etc/init.d/test.php 2>&1 &) > /var/state/ls.log";
		$cmd .= ' > '.$log;
		echo 'launcher: run command: '.$cmd."\n";
		exec($cmd);
	}
}

$f = fopen($state_done, 'w');
fwrite($f, "done");
fclose($f);

echo "launcher: finish\n";
?>
