<?php
/*!*******************************************************************************
*! FILE NAME  : jhead.php
*! DESCRIPTION: different JFIF headers for JP4 variants (deviate from JFIF)
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: jhead.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:03  elphel
*!
*!
*!  Revision 1.2  2008/05/18 02:25:13  elphel
*!  changed color components numbers to facilitate JP4 flavors detection from SOF and SOS tags
*!
*!  Revision 1.1  2008/05/16 06:05:36  elphel
*!  added script to modify JFIF headers (for JP4 experiments)
*!
*/
$head_SOF_pos=0x9e;

function read_SOF() {
 global $sbuf,$pos,$SOI,$APP0,$DQT,$SOF,$DHT,$SOS;

 $sof_tag= ord($sbuf[$pos])*256+ord($sbuf[$pos+1]);
 if ($sof_tag != 0xffc0) {
   printf ("wrong SOF tag 0x%04x (expected 0x%04x)\n",$sof_tag,0xffc0);
   exit(1);
 }
 $len=ord($sbuf[$pos+2])*256+ord($sbuf[$pos+3]);
 $SOF=substr($sbuf,$pos,$len+2);
 $pos+=(2+$len);
 printf ("SOF: len=0x%x\n",$len);
}

function read_DHT() {
 global $sbuf,$pos,$SOI,$APP0,$DQT,$SOF,$DHT,$SOS;
 $DHT="";
 while (($dht_tag= ord($sbuf[$pos])*256+ord($sbuf[$pos+1]))==0xffc4) {
   $len=ord($sbuf[$pos+2])*256+ord($sbuf[$pos+3]);
   $DHT.=substr($sbuf,$pos,$len+2); 
   $pos+=(2+$len);
   printf ("DHT: len=0x%x\n",$len);
 }
}
function read_SOS() {
 global $sbuf,$pos,$SOI,$APP0,$DQT,$SOF,$DHT,$SOS;

 $sos_tag= ord($sbuf[$pos])*256+ord($sbuf[$pos+1]);
 if ($sos_tag != 0xffda) {
   printf ("wrong SOS tag 0x%04x (expected 0x%04x)\n",$sof_tag,0xffda);
   exit(1);
 }
 $len=ord($sbuf[$pos+2])*256+ord($sbuf[$pos+3]);
 $SOS=substr($sbuf,$pos,$len+2);
 $pos+=(2+$len);
 printf ("SOS len=0x%x\n",$len);
}

function print_SOF() {
 global $SOF;
 $pos=4;
 $bits=ord($SOF[$pos++]);
 $height=256*ord($SOF[$pos++])+ord($SOF[$pos++]);
 $width= 256*ord($SOF[$pos++])+ord($SOF[$pos++]);
 $num_comp=ord($SOF[$pos++]);
 $comps=array();
 for ($i=0; $i<$num_comp; $i++) {
   $id= ord($SOF[$pos++]);
   $freq=ord($SOF[$pos++]);
   $qtab=ord($SOF[$pos++]);
   $comps[]=array("id"=>$id,"fh"=>$freq>>4,"fv"=>$freq & 0xf, "qtab"=>$qtab);
 }
 printf ("\nSOF:\n");
 printf ("   bits=  0x%x\n",$bits);
 printf ("   width= %d (0x%x)\n",$width,$width);
 printf ("   height=%d (0x%x)\n",$height,$height);
 foreach ($comps as $entry) {
   printf("   id=%d, fh=%d, fv=%d, qtab=%d\n",$entry["id"], $entry["fh"], $entry["fv"], $entry["qtab"]);
 }
// var_dump($comps);
}

function print_SOS() {
 global $SOS;
 $pos=4;
 $num_comp=ord($SOS[$pos++]);
 $comps_sos=array();
 for ($i=0; $i<$num_comp; $i++) {
   $id= ord($SOS[$pos++]);
   $dht=ord($SOS[$pos++]);
   $comps_sos[]=array("id"=>$id,"dht_dc"=>$dht>>4,"dht_ac"=>$dht & 0xf);
 }
 printf ("\nSOS:\n");
 foreach ($comps_sos as $entry) {
   printf("   id=%d, dht_dc=%d, dht_ac=%d\n",$entry["id"], $entry["dht_dc"], $entry["dht_ac"]);
 }
// var_dump($comps_sos);
}

function read_header() {
 global $sbuf,$pos,$head_SOF_pos;
echo "<pre>\n";
 $jhfile=fopen("/dev/jpeghead","r+");
 $sbuf=fread($jhfile, 8192);
 fclose($jhfile);
$pos=$head_SOF_pos;
 printf ("pos=0x%x\n",$pos);
 read_SOF();
 printf ("pos=0x%x\n",$pos);
 read_DHT();
 printf ("pos=0x%x\n",$pos);
 read_SOS();
 printf ("pos=0x%x\n",$pos);
echo "</pre>\n";
}
function write_header() {
 global $sbuf;
echo "<pre>\n";
 $jhfile=fopen("/dev/jpeghead","w+");
 $l=fwrite($jhfile, $sbuf);
 fclose($jhfile);
 printf ("Written %d (0x%x) bytes to /dev/jpeghead\n",strlen($sbuf),strlen($sbuf));
echo "</pre>\n";
}


function show_header() {
echo "<pre>\n";
 print_SOF();
 print_SOS();
echo "</pre>\n";
}


function set_color6() {
  global $SOF_arr, $SOS_arr;
  $SOF_arr=array (
    array ("id"=>1, "fh"=>2, "fv"=>2,"qtab"=>0),
    array ("id"=>2, "fh"=>1, "fv"=>1,"qtab"=>1),
    array ("id"=>3, "fh"=>1, "fv"=>1,"qtab"=>1));
  $SOS_arr=array (
    array("id"=>1, "dht_dc"=>0, "dht_ac"=>0),
    array("id"=>2, "dht_dc"=>1, "dht_ac"=>1),
    array("id"=>3, "dht_dc"=>1, "dht_ac"=>1));
}

function set_jp46dc() {
  global $SOF_arr, $SOS_arr;
  $SOF_arr=array (
    array ("id"=>1, "fh"=>1, "fv"=>1,"qtab"=>0),
    array ("id"=>2, "fh"=>1, "fv"=>1,"qtab"=>0),
    array ("id"=>3, "fh"=>1, "fv"=>1,"qtab"=>0),
    array ("id"=>4, "fh"=>1, "fv"=>1,"qtab"=>0),
    array ("id"=>5, "fh"=>1, "fv"=>1,"qtab"=>1),
    array ("id"=>6, "fh"=>1, "fv"=>1,"qtab"=>1));
  $SOS_arr=array (
    array("id"=>1, "dht_dc"=>0, "dht_ac"=>0),
    array("id"=>2, "dht_dc"=>0, "dht_ac"=>0),
    array("id"=>3, "dht_dc"=>0, "dht_ac"=>0),
    array("id"=>4, "dht_dc"=>0, "dht_ac"=>0),
    array("id"=>5, "dht_dc"=>1, "dht_ac"=>1),
    array("id"=>6, "dht_dc"=>1, "dht_ac"=>1));
}


function set_mono4() {
  global $SOF_arr, $SOS_arr;
  $SOF_arr=array (
    array ("id"=>1, "fh"=>2, "fv"=>2,"qtab"=>0));
  $SOS_arr=array (
    array("id"=>1, "dht_dc"=>0, "dht_ac"=>0));
}

function set_jp4($bayer) {
  global $SOF_arr, $SOS_arr;
  $SOF_arr=array (
    array ("id"=>4+$bayer, "fh"=>2, "fv"=>2,"qtab"=>0));
  $SOS_arr=array (
    array("id"=>4+$bayer, "dht_dc"=>0, "dht_ac"=>0));
}

function set_jp4dc($bayer) {
  global $SOF_arr, $SOS_arr;
  $SOF_arr=array (
    array ("id"=>4+(($bayer+0) & 3), "fh"=>1, "fv"=>1,"qtab"=>0),
    array ("id"=>4+(($bayer+1) & 3), "fh"=>1, "fv"=>1,"qtab"=>0),
    array ("id"=>4+(($bayer+2) & 3), "fh"=>1, "fv"=>1,"qtab"=>0),
    array ("id"=>4+(($bayer+3) & 3), "fh"=>1, "fv"=>1,"qtab"=>0));
  $SOS_arr=array (
    array("id"=>4+(($bayer+0) & 3), "dht_dc"=>0, "dht_ac"=>0),
    array("id"=>4+(($bayer+1) & 3), "dht_dc"=>0, "dht_ac"=>0),
    array("id"=>4+(($bayer+2) & 3), "dht_dc"=>0, "dht_ac"=>0),
    array("id"=>4+(($bayer+3) & 3), "dht_dc"=>0, "dht_ac"=>0));
}
function set_jp4diff($bayer) {
  global $SOF_arr, $SOS_arr;
  $SOF_arr=array (
    array ("id"=>4+(($bayer+0) & 3), "fh"=>1, "fv"=>1,"qtab"=>1),
    array ("id"=>4+(($bayer+1) & 3), "fh"=>1, "fv"=>1,"qtab"=>1),
    array ("id"=>4+(($bayer+2) & 3), "fh"=>1, "fv"=>1,"qtab"=>1),
    array ("id"=>4+(($bayer+3) & 3), "fh"=>1, "fv"=>1,"qtab"=>1));
  $SOS_arr=array (
    array("id"=>4+(($bayer+0) & 3), "dht_dc"=>1, "dht_ac"=>1),
    array("id"=>4+(($bayer+1) & 3), "dht_dc"=>1, "dht_ac"=>1),
    array("id"=>4+(($bayer+2) & 3), "dht_dc"=>1, "dht_ac"=>1),
    array("id"=>4+(($bayer+3) & 3), "dht_dc"=>1, "dht_ac"=>1));
  $SOF_arr[(4-$bayer) & 3]["qtab"]=0;
  $SOS_arr[(4-$bayer) & 3]["dht_dc"]=0;
  $SOS_arr[(4-$bayer) & 3]["dht_ac"]=0;
}
function set_jp4hdr($bayer) {
  global $SOF_arr, $SOS_arr;
  $SOF_arr=array (
    array ("id"=>4+(($bayer+0) & 3), "fh"=>1, "fv"=>1,"qtab"=>1),
    array ("id"=>4+(($bayer+1) & 3), "fh"=>1, "fv"=>1,"qtab"=>1),
    array ("id"=>4+(($bayer+2) & 3), "fh"=>1, "fv"=>1,"qtab"=>1),
    array ("id"=>4+(($bayer+3) & 3), "fh"=>1, "fv"=>1,"qtab"=>1));
  $SOS_arr=array (
    array("id"=>4+(($bayer+0) & 3), "dht_dc"=>1, "dht_ac"=>1),
    array("id"=>4+(($bayer+1) & 3), "dht_dc"=>1, "dht_ac"=>1),
    array("id"=>4+(($bayer+2) & 3), "dht_dc"=>1, "dht_ac"=>1),
    array("id"=>4+(($bayer+3) & 3), "dht_dc"=>1, "dht_ac"=>1));
  $SOF_arr[(4-$bayer) & 3]["qtab"]=0;
  $SOS_arr[(4-$bayer) & 3]["dht_dc"]=0;
  $SOS_arr[(4-$bayer) & 3]["dht_ac"]=0;
  $SOF_arr[(6-$bayer) & 3]["qtab"]=  0;
  $SOS_arr[(6-$bayer) & 3]["dht_dc"]=0;
  $SOS_arr[(6-$bayer) & 3]["dht_ac"]=0;
}

function encode_SOF() {
  global $SOF_arr,$SOF;
  $SOF=substr($SOF,0,9);
  $SOF.=chr(count($SOF_arr));
  foreach ($SOF_arr as $entry) {
    $SOF.=chr($entry["id"]);
    $SOF.=chr(($entry["fh"]<<4) | ($entry["fv"] & 0x0f));
    $SOF.=chr($entry["qtab"]);
  }
  $SOF[3]=chr(strlen($SOF)-2);
}

function encode_SOS() {
  global $SOS_arr,$SOS;
  $SOS=substr($SOS,0,4);
  $SOS.=chr(count($SOS_arr));
  foreach ($SOS_arr as $entry) {
    $SOS.=chr($entry["id"]);
    $SOS.=chr(($entry["dht_dc"]<<4) | ($entry["dht_ac"] & 0x0f));
  }
  $SOS.=chr(0).chr(0x3f).chr(0);
  $SOS[3]=chr(strlen($SOS)-2);
}

function  make_new() {
 global $sbuf,$pos,$SOI,$APP0,$DQT,$SOF,$DHT,$SOS,$SOF_arr,$SOS_arr,$head_SOF_pos;
 $sbuf=substr($sbuf,0,$head_SOF_pos);
 $sbuf.=$SOF.$DHT.$SOS;
}


// main

 switch ($_GET["shift"]) {
   case "1": $shift=1; break;
   case "2": $shift=2; break;
   case "3": $shift=3; break;
   case "0":
   default: $shift=0;
 }

echo "shift=".$shift;
 read_header();
 switch ($_GET["cmd"]) {
   case "jp4hdr":   set_jp4hdr($shift); break;
   case "jp4diff":  set_jp4diff($shift); break;
   case "jp4dc":    set_jp4dc($shift); break;

   case "jp4":  set_jp4($shift); break;
   case "mono":
   case "mono4":
      set_mono4();
      break;
   case "jp46dc":
      set_jp46dc();
      break;
   case "jp46":
   case "mono6":
   case "color":
      set_color6();
      break;
   case "show":
   default:
   show_header();
   exit(0);
 }
//echo "$SOF_arr"; var_dump($SOF_arr);
//echo "$SOS_arr"; var_dump($SOS_arr);
 encode_SOF();
 encode_SOS();
 make_new();
 show_header();
 write_header();
 read_header();
 show_header();
?>