<?php
/*!***************************************************************************
*! FILE NAME  : mshutter.php
*! DESCRIPTION: controls mechanical shutters (sequencer)
*! Copyright (C) 2007 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: mshutter.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:03  elphel
*!
*!
*!  Revision 1.1  2007/12/06 19:02:51  elphel
*!  collected most of the camera PHP script into one  /packages/web/353/php_top directory
*!
*!  Revision 1.2  2007/10/12 05:33:53  elphel
*!  Fixed wrong fillout of the "Even exposures" form
*!
*!  Revision 1.1.1.1  2007/10/10 05:43:21  elphel
*!  This is a fresh tree based on elphel353-2.10
*!
*/

//slow version of functions - they will reopen i2c for each word
function send347($register_address,$d0=0,$d1=-1,$d2=-1,$d3=-1,$d4=-1,$d5=-1,$d6=-1,$d7=-1) {
   $i2c  = fopen('/dev/xi2c16', 'w');
   fseek ($i2c, 0x2000+2*$register_address) ; //Micron sensor slave 0xba
   fwrite($i2c, chr (floor($d0/256)).chr ($d0-256*floor($d0/256)));
   if ($d1>=0) {
    fwrite($i2c, chr (floor($d1/256)).chr ($d1-256*floor($d1/256)));
    if ($d2>=0) {
     fwrite($i2c, chr (floor($d2/256)).chr ($d2-256*floor($d2/256)));
     if ($d3>=0) {
      fwrite($i2c, chr (floor($d3/256)).chr ($d3-256*floor($d3/256)));
      if ($d4>=0) {
       fwrite($i2c, chr (floor($d4/256)).chr ($d4-256*floor($d4/256)));
       if ($d5>=0) {
        fwrite($i2c, chr (floor($d5/256)).chr ($d5-256*floor($d5/256)));
        if ($d6>=0) {
         fwrite($i2c, chr (floor($d6/256)).chr ($d6-256*floor($d6/256)));
         if ($d7>=0) {
          fwrite($i2c, chr (floor($d7/256)).chr ($d7-256*floor($d7/256)));
         }
        }
       }
      }
     }
    }
   }
   fclose($i2c);
}

function receive347($register_address) { // very slow?
   $i2c  = fopen('/dev/xi2c16', 'r');
   fseek ($i2c, 0x2000+2*$register_address) ; //Micron sensor slave 0xba
   $data = fread($i2c, 2);
   fclose($i2c);
   $v=unpack('n1',$data);
//   var_dump($v);
   return $v[1];
}


function i2cread16 ($start,$length=256) {
   $i2c  = fopen('/dev/xi2c16', 'r');
   fseek ($i2c, 2*$start) ; // 16-bit registers
   $data = fread($i2c, 2*$length);
   fclose($i2c);
   $regs=unpack('n*',$data);
//   print_r($regs);
   echo "<table>\n";
   for ($i=0; $i<$length; $i+=16){
     printf("<tr><td>%x</td>",$i);
     for ($j=1; $j<17; $j++){
       printf("<td>%x</td>",$regs[$i+$j]);
     }
     echo "</tr>\n";
   }
   echo "</table>\n";
}

function nicefloaty($f) {
  $s=sprintf("%f",$f);
  if (strpos($s, ".") !== false) $s=rtrim ( $s, "0" );
  return rtrim ( $s, "." );
}
function write_coil_form($coil1,$coil2,$coil3,$coil4,$alternate,$coil1e,$coil2e,$coil3e,$coil4e) {
   $tick=$GLOBALS['tick'];
   $tick_us=$tick*1000;
   if ($alternate) {
    $head1="<tr><td colspan=\"2\"><b>Odd exposures</b></td></tr>\n";
    $table_even="<tr><td colspan=\"2\"><b>Even exposures</b></td></tr>\n".
                "<tr><td>coil1:</td><td> <input name=\"coil1_e\" type=\"text\" size=\"80\" value=\"$coil1e\"/> </td></tr>\n".
                "<tr><td>coil2:</td><td> <input name=\"coil2_e\" type=\"text\" size=\"80\" value=\"$coil2e\"/> </td></tr>\n".
                "<tr><td>coil3:</td><td> <input name=\"coil3_e\" type=\"text\" size=\"80\" value=\"$coil3e\"/> </td></tr>\n".
                "<tr><td>coil4:</td><td> <input name=\"coil4_e\" type=\"text\" size=\"80\" value=\"$coil4e\"/> </td></tr>\n";
   } else {
    $head1="";
    $table_even="";
   }
   echo "<form action=\"$self\" method=\"post\">";
    echo <<<HTMLFORM
   <p>You may specify individual sequences for each coil, sequence consists of command_letter and duration pairs (no spaces are required but allowed). Here is an example:</p>
   <pre>
   f1 b1.5 p5 r 2.1 b1.5
   </pre>
   <p>Forward 1 ms, brake for 1.5ms, pause for 5 ms, reverse for 2.1ms and finally brake for 1.5ms.</p>
   <ul>
    <li><b>p</b> - initial state of the coil, both ends shorted to ground (should not leave this state for more than 15ms)</li>
    <li><b>d</b> - forward </li>
    <li><b>r</b> - reverse </li>
    <li><b>b</b> - brake - coil is allowed to develop voltage equal to the power supply - limited by the H-bridge diodes </li>
   </ul>
   <p>Delay after the command letter is specified in ms, minimal delay/dealy step is $tick ms ($tick_us us). If delay is ommitted it will default to $tick.</p>
   <input type="hidden" name="is_post" value="it_is">
    <table>
     $head1
     <tr><td>coil1:</td><td> <input name="coil1" type="text" size="80" value="$coil1"/> </td></tr>
     <tr><td>coil2:</td><td> <input name="coil2" type="text" size="80" value="$coil2"/> </td></tr>
     <tr><td>coil3:</td><td> <input name="coil3" type="text" size="80" value="$coil3"/> </td></tr>
     <tr><td>coil4:</td><td> <input name="coil4" type="text" size="80" value="$coil4"/> </td></tr>
     $table_even
     <tr><td colspan="2"> <input type="submit" /> </td></tr>
    </table> 
   </form>
HTMLFORM;

}
function parse_seq($sec_str,$chn){
  $times=array();
  $states=array();
  $channels=array();
  $tick=$GLOBALS['tick']; 
  $s=strtolower ($sec_str);
  $s=str_replace (" ","",$s);
  $s=str_replace ("d"," d ",$s);
  $s=str_replace ("f"," d ",$s);
  $s=str_replace ("r"," r ",$s);
  $s=str_replace ("p"," p ",$s);
  $s=str_replace ("n"," p ",$s);
  $s=str_replace ("b"," b ",$s);
  $s=str_replace ("  "," ",$s);
  $s=trim($s);
  if ($s=="") return array ("times"=>$times,"channels"=>$channels,"states"=>$states); // empty sequence - don't add " p"
  $s.= " p";
  $a=explode(" ", $s);
  foreach ($a as $value) {
    if      ($value =="p") $p[]= array(0,1);
    else if ($value =="d") $p[]= array(1,1);
    else if ($value =="r") $p[]= array(2,1);
    else if ($value =="b") $p[]= array(3,1);
    else  {
       sscanf($value,"%f",$f);
       $f=round($f/$tick); if ($f<1) $f=1;
       $p[count($p)-1][1]=$f;
    }
  }

  unset ($a);
  $time=0;
  foreach ($p as $value) {
   $times[]=$time;
   $states[]=$value[0];
   $channels[]=$chn;
   $time+=$value[1];
  }
  return array ("times"=>$times,"channels"=>$channels,"states"=>$states);
}
function seq_table ($seq) {
    echo "<table border=\"1\">\n <tr><td>Time (ms)</td><td>1</td><td>2</td><td>3</td><td>4</td></tr>\n";
    foreach ($seq as $time => $state) 
//      printf ("<tr><td>%f</td><td>%d</td><td>%d</td><td>%d</td><td>%d</td></tr>\n",
      printf ("<tr><td>%s</td><td>%02b</td><td>%02b</td><td>%02b</td><td>%02b</td></tr>\n",
             nicefloaty($time*$GLOBALS['tick']),
             ($state >> 0) & 3,
             ($state >> 2) & 3,
             ($state >> 4) & 3,
             ($state >> 6) & 3);
    echo "</table>";
}
function seq_send ($seq,$adr) {
//  $adr=$GLOBALS['mshutter_seq'];
  $seqtime=0;
  $pstate=0;
  foreach ($seq as $time => $state) {
    $duration=$time-$seqtime;
    if ($duration>0) {
     $msw=0x9000 | (($pstate & 0xff) << 4) | ((($duration-1) >> 16) & 0xf);
     $lsw=(($duration-1) & 0xffff);
     send347 ($adr,$lsw, $msw);
     $adr+=2;
    }
    $seqtime=$time;
    $pstate=$state;
  }
  send347 ($adr,0, 0); // end sequence
}

//receive347($register_address)
function seq_receive($adr,$length) { // seq array
//  $adr=$GLOBALS['mshutter_seq'];
//  $length=0x100;
  $i2c  = fopen('/dev/xi2c16', 'r');
  fseek ($i2c,  0x2000+2*$adr) ; // 16-bit registers

  $data = fread($i2c, 2*$length);
  fclose($i2c);
  $regs=unpack('n*',$data);
//  print_r ($regs);
  $seqtime=0;
  $state=0;
  $seq=array();
  $i=1;
  for (;;) {
    $lsw=$regs[$i++];
    $msw=$regs[$i++];
    if (!($msw & 0x8000)) break;
//    printf ("lsw=%x, msw=%x, seqtime=%x\n",$lsw,$msw,$seqtime);
    if (($msw & 0xf000)==0x9000) $seq[$seqtime]= ($msw >> 4) & 0xff; // state
    $seqtime += ( $lsw | (($msw & 0xf)<<16))+1; // nop commands can add duration, each command adds 1 tick also
  }
//  printf ("---- lsw=%x, msw=%x, seqtime=%x\n",$lsw,$msw,$seqtime);
  $seq[$seqtime]= 0; // state
  return $seq;
}

function seq_extract_channel($seq, $chn) { // extract individual channel (1..4) from the sequencer
   $seqtime=0;
   $seqstate=0;
   $s="";
   $cmds="pfrb";
   $tick=$GLOBALS['tick'];
   foreach ($seq as $time => $state) {
      if ((($state >> (2*($chn-1))) & 3) != $seqstate) {
        if ($time > $seqtime) {
//           $s .= " " . ($cmds[$seqstate]) . nicefloaty(($time-$seqtime)*$GLOBALS['tick']);
           $dt=($time-$seqtime); //integer ticks
           $dtus=round(1000*$dt*$tick);
//   printf ("dtus=%f, round(dtus/(1000*tick))=%d, dt=%d<br/>\n",$dtus,round($dtus/(1000*$tick)),$dt);
           if (round($dtus/(1000*$tick))==$dt) $dt=0.001*$dtus;
           else $dt *= $tick;
           $s .= " " . ($cmds[$seqstate]) . nicefloaty($dt);
        }
        $seqstate= (($state >> (2*($chn-1))) & 3);
        $seqtime=$time;
      }
   }
   return trim($s);
}

// main starts here:

$GLOBALS['mshutter_alternate']=1;
$GLOBALS['mshutter_seq']=0x200;
$GLOBALS['mshutter_seq_even']=0x280;
$GLOBALS['tick']=0.000008*4*(receive347(0x70)+1);
echo <<<HEADER
<html>
  <head>
    <title></title>
    <meta content="">
    <style></style>
  </head>
  <body>
HEADER;
echo "<p><i>sequencer tick=" . $GLOBALS['tick'] . "ms</i></p>";
// make that first time only reads FPGA
if ($_POST['is_post'] == 'it_is') {
  $icoil1 =$_POST['coil1'];
  $icoil2 =$_POST['coil2'];
  $icoil3 =$_POST['coil3'];
  $icoil4 =$_POST['coil4'];
  $coil1 = parse_seq($icoil1,1);
  $coil2 = parse_seq($icoil2,2);
  $coil3 = parse_seq($icoil3,3);
  $coil4 = parse_seq($icoil4,4);

  $coils=array ("times"=>   array_merge($coil1["times"],    $coil2["times"],    $coil3["times"],    $coil4["times"]),
                "channels"=>array_merge($coil1["channels"], $coil2["channels"], $coil3["channels"], $coil4["channels"]),
                "states"=>  array_merge($coil1["states"],   $coil2["states"],   $coil3["states"],   $coil4["states"]));
  array_multisort($coils["times"],$coils["channels"],$coils["states"]);
//  print_r($coils);
  $seq=array();
  $state=0;
  for ($i=0;$i<count($coils["times"]);) {
    $ti=$coils["times"][$i];
    $state &= ~(3  << (2 * ($coils["channels"][$i]-1)));
    $state |=  $coils["states"][$i] << (2 * ($coils["channels"][$i]-1)); 
    for ($j=$i+1; $tj=$coils["times"][$j], $ti==$tj;$j++) {
      $state &= ~(3  << (2 * ($coils["channels"][$j]-1)));
      $state |=  $coils["states"][$j] << (2 * ($coils["channels"][$j]-1));
    }  
    $seq[$ti]= $state;
    $i=$j;
  }
  seq_table ($seq);

  if ($GLOBALS['mshutter_alternate']) {
    $icoil1_e =$_POST['coil1_e'];
    $icoil2_e =$_POST['coil2_e'];
    $icoil3_e =$_POST['coil3_e'];
    $icoil4_e =$_POST['coil4_e'];
    $coil1_e = parse_seq($icoil1_e,1);
    $coil2_e = parse_seq($icoil2_e,2);
    $coil3_e = parse_seq($icoil3_e,3);
    $coil4_e = parse_seq($icoil4_e,4);
    $coils_e=array ("times"=>   array_merge($coil1_e["times"],    $coil2_e["times"],    $coil3_e["times"],    $coil4_e["times"]),
                    "channels"=>array_merge($coil1_e["channels"], $coil2_e["channels"], $coil3_e["channels"], $coil4_e["channels"]),
                    "states"=>  array_merge($coil1_e["states"],   $coil2_e["states"],   $coil3_e["states"],   $coil4_e["states"]));
    array_multisort($coils_e["times"],$coils_e["channels"],$coils_e["states"]);
//  print_r($coilse);
    $seq_e=array();
    $state_e=0;
    for ($i=0;$i<count($coils_e["times"]);) {
      $ti=$coils_e["times"][$i];
      $state_e &= ~(3  << (2 * ($coils_e["channels"][$i]-1)));
      $state_e |=  $coils_e["states"][$i] << (2 * ($coils_e["channels"][$i]-1)); 
      for ($j=$i+1; $tj=$coils_e["times"][$j], $ti==$tj;$j++) {
        $state_e &= ~(3  << (2 * ($coils_e["channels"][$j]-1)));
        $state_e |=  $coils_e["states"][$j] << (2 * ($coils_e["channels"][$j]-1));
      }
      $seq_e[$ti]= $state_e;
      $i=$j;
    }
    seq_table ($seq_e);
  }
 
    if ($GLOBALS['mshutter_alternate']) {
      seq_send ($seq,$GLOBALS['mshutter_seq']);
      $seq=seq_receive($GLOBALS['mshutter_seq'],0x80);
      seq_send ($seq_e,$GLOBALS['mshutter_seq_even']);
      $seq_e=seq_receive($GLOBALS['mshutter_seq_even'],0x80);

      write_coil_form(seq_extract_channel($seq, 1),
                      seq_extract_channel($seq, 2),
                      seq_extract_channel($seq, 3),
                      seq_extract_channel($seq, 4),
                      1,
                      seq_extract_channel($seq_e, 1),
                      seq_extract_channel($seq_e, 2),
                      seq_extract_channel($seq_e, 3),
                      seq_extract_channel($seq_e, 4));
    } else {
      seq_send ($seq,$GLOBALS['mshutter_seq']);
      $seq=seq_receive($GLOBALS['mshutter_seq'],0x100);
      write_coil_form(seq_extract_channel($seq, 1),
                      seq_extract_channel($seq, 2),
                      seq_extract_channel($seq, 3),
                      seq_extract_channel($seq, 4),0,"","","","");
    }
  } else {
    if ($GLOBALS['mshutter_alternate']) {
      $seq=seq_receive($GLOBALS['mshutter_seq'],0x80);
      $seq_e=seq_receive($GLOBALS['mshutter_seq_even'],0x80);
//    echo "<pre>\n"; 
//    print_r($seq);
//    print_r($seq_e);
//    echo "</pre>\n"; 

      write_coil_form(seq_extract_channel($seq, 1),
                      seq_extract_channel($seq, 2),
                      seq_extract_channel($seq, 3),
                      seq_extract_channel($seq, 4),
                      1,
                      seq_extract_channel($seq_e, 1),
                      seq_extract_channel($seq_e, 2),
                      seq_extract_channel($seq_e, 3),
                      seq_extract_channel($seq_e, 4));
    } else {
      $seq=seq_receive($GLOBALS['mshutter_seq'],0x100);
      write_coil_form(seq_extract_channel($seq, 1),
                      seq_extract_channel($seq, 2),
                      seq_extract_channel($seq, 3),
                      seq_extract_channel($seq, 4),0,"","","","");
    }
  }
echo <<<FOOTER
  </body>
</html>
FOOTER;
?>
