<?php 
function fpga_read($addr) {
       $fpga  = fopen('/dev/fpgaio', 'r');
       fseek ($fpga, $addr) ; // 32-bit registers
       $d = fread($fpga, 4);
       fclose($fpga);
       $regs=unpack('V*',$d); // unsigned long, little endian
       return $regs[1];
     }
function fpga_write($addr,$data) {
       $fpga  = fopen('/dev/fpgaio', 'w');
       fseek ($fpga, $addr) ; // 32-bit registers
       fwrite($fpga, chr($data & 0xff).chr(($data>>8) & 0xff).chr(($data>>16) & 0xff).chr(($data>>24) & 0xff));
       fclose($fpga);
    }

function sendi2c16($register_address,$d0=0) {
   $i2c  = fopen('/dev/xi2c16', 'w');
   fseek ($i2c, 2*$register_address) ; //Micron sensor slave 0xba
   fwrite($i2c, chr (floor($d0/256)).chr ($d0-256*floor($d0/256)));
   fclose($i2c);
}

function i2cread16 ($start,$length=256) {
   $i2c  = fopen('/dev/xi2c16', 'r');
   fseek ($i2c, 2*$start) ; // 16-bit registers
   $data = fread($i2c, 2*$length);
   fclose($i2c);
   $regs=unpack('n*',$data);
//   print_r($regs);
   echo "<table>\n";
   for ($i=0; $i<$length; $i+=16){
     printf("<tr><td>%x</td>",$i);
     for ($j=1; $j<17; $j++){
       printf("<td>%x</td>",$regs[$i+$j]);
     }
     echo "</tr>\n";
   }
   echo "</table>\n";
}

 $trigger=$_GET['trigger'];
 $delay=$_GET['delay'];
 $exit=$_GET['exit']; // exit sync mode, resume continuous acquisition (may need to increase vblank!)

 if ($exit) {
   $cmdfile=fopen('/dev/sensorpars', 'r');
   fseek ($cmdfile,0x0d, SEEK_END) ; // stop compressor, 0x0a - start
   fclose($cmdfile);

    exec ("fpcf -c c 1"); // reset bit 12 of the control register,ARO (TRIGGER) output will just follow level on CR[10]
   sendi2c16(0x4806,0x400); //should be enough, but maybe too slow - ccam.cgi will change that
// continuous mode
   sendi2c16(0x481e,0x4006); //snapshot - 0x4106
//set continuous compression
  exit (0);
 }


 if ($trigger && is_numeric ($trigger)) $trigger=$trigger+0;
 else $trigger=0xb00000; // gpio[11] -\_, gpio[100 _/-

 if ($delay && is_numeric ($delay))   $delay=$delay+0;
 else $delay=0;



    fpga_write(0x7b, 0x1); // actually it is a bug in FPGA - needed to ennable delay counter

//program trigger condition to be 10 on 2 MSBs
$trigger_delay=$delay;
    fpga_write(0x78, $trigger);
// program trigger delay
    fpga_write(0x79, $trigger_delay);
// enable trigger output
    exec ("fpcf -c c 2"); // set bit 12 of the control register
// change sensor to snapshot mode:
// set minimal vblank
   sendi2c16(0x4806,0x19);
// snapshot mode
   sendi2c16(0x481e,0x4106); //continuous - 0x4006
//wait pending frames to finish (not really important, but makes sure useful frames in circbuf start from 0)
   sleep (1);
//set continuous compression
   $cmdfile=fopen('/dev/sensorpars', 'r');
   fseek ($cmdfile,0x0a, SEEK_END) ; // run compressor, 0x0d - stop
   fclose($cmdfile);
//i2cread16(0x4800,0x100);
?> 
