<?php
/*!***************************************************************************
*! FILE NAME  : trig.php
*! DESCRIPTION: Controls triggering of 10347 CCD timing board
*! Copyright (C) 2007 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: trig.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:03  elphel
*!
*!
*!  Revision 1.1  2007/12/06 19:02:53  elphel
*!  collected most of the camera PHP script into one  /packages/web/353/php_top directory
*!
*!  Revision 1.4  2007/10/31 04:59:41  elphel
*!  Included changes by Diego
*!
*!  Revision 1.3  2007/10/16 20:03:06  elphel
*!  removed irrelevant comment
*!
*!  Revision 1.2  2007/10/12 23:00:46  elphel
*!  adding power347.php to control power supplies and power timeout (supporting new FPGA interface)
*!
*!  Revision 1.1  2007/10/11 06:43:56  elphel
*!  Added two small PHP scripts to controll compressor (all sensors) and trigger (CCD with 10347 board only)
*!
*!
*/


//slow version of functions - they will reopen i2c for each word
function send347($register_address,$d0=0) {
   $i2c  = fopen('/dev/xi2c16', 'w');
   fseek ($i2c, 0x2000+2*$register_address) ;
   fwrite($i2c, chr (floor($d0/256)).chr ($d0-256*floor($d0/256)));
   fclose($i2c);
}

//print_r ($_GET);
 switch  ($_GET['cmd']) {
  case "immed":    send347(0x14,0); print "OK immed"; break; 
  case "arm":      send347(0x14,3); print "OK arm"; break; 
  case "disarm":   send347(0x14,2); print "OK disarm";  break; 
  case "single":   send347(0x14,1); print "OK single"; break; 
  case "fireall":  send347(0x14,4); print "OK fireall"; break; 
  default:
    echo <<<USAGE
   <p>This script controls triggering of 10347 CCD timing board:</p>
   <ul>
    <li><b>cmd=immed</b> - immediately trigger this camera module</li>
    <li><b>cmd=arm</b> -   arm camera to accept external trigger</li>
    <li><b>cmd=disarm</b> - disarm camera (will ignore trigger) </li>
    <li><b>cmd=single</b> - arm camera for one external trigger only, then disarm </li>
    <li><b>cmd=fireall</b> - generate external trigger out pulse </li>
  </ul>
USAGE;
  }


?>
