# Hey Emacs, this Makefile is in -*- makefile -*- mode!

###########################################################################

define recurse_template
$(1):	do-$(1)-recurse
endef

###########################################################################

AXIS_RECURSIVE_TARGETS += all
AXIS_RECURSIVE_TARGETS += install
AXIS_RECURSIVE_TARGETS += uninstall
AXIS_RECURSIVE_TARGETS += clean
AXIS_RECURSIVE_TARGETS += check

AXIS_RECURSIVE_TARGETS += $(AXIS_BUILDTYPES)

###########################################################################

$(foreach target, $(AXIS_RECURSIVE_TARGETS), $(eval $(call recurse_template,$(target))))

$(patsubst %, do-%-recurse, $(AXIS_RECURSIVE_TARGETS))  do-opt-%-recurse:
# The next line is just to keep this rule from being empty if
# NO_SUBDIR_RECURSION is set, since make does not consider empty implicit rules
# as targets...
	@
ifneq ($(NO_SUBDIR_RECURSION),1)
	@subdirs="$(SUBDIRS)"; \
	echo "subdirs=$(SUBDIRS)" ; \
	for subdir in $$subdirs; do \
	 if ! [ "$$subdir" = "." ]; then \
	  if [ -d "$$subdir" ] ; then \
	    target=`echo $@ | sed 's/^do-\(.*\)-recurse/\1/'`; \
	    echo "Making $$target in $$subdir for $(AXIS_BUILDTYPE)"; \
	    $(MAKE) -C "$$subdir" $$target || [ "$(MAKECMDGOALS)" = "check" ] || exit 1; \
	  else \
	    echo "The directory '$$subdir' does not exist or is not a directory!"; \
	    exit 1; \
	  fi; \
	 else \
	    echo "******* New! Processing '.' directory if listed in 'subdirs=', but using NO_SUBDIR_RECURSION=1 ********"; \
	    echo "$$@"; \
	    target=`echo $@ | sed 's/^do-\(.*\)-recurse/\1/'`; \
	    echo "Making $$target in $$subdir for $(AXIS_BUILDTYPE)"; \
	    NO_SUBDIR_RECURSION=1 $(MAKE) -C "$$subdir" $$target || [ "$(MAKECMDGOALS)" = "check" ] || exit 1; \
	 fi ; \
	done
endif

#--------------------------------------------------------------------------

# We want to be able to use the options rules even if targets.mak has not been
# included.
ifndef TARGETS_MAK_INCLUDED
opt-%:	do-opt-%-recurse
	@

debug:		opt-debug
nodebug:	opt-no-debug
static:		opt-static
nostatic:	opt-no-static
endif

###########################################################################
